
/*  A Bison parser, made from parse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	CLASS	257
#define	FROM	258
#define	CONST	259
#define	VOID	260
#define	STRUCT	261
#define	UNION	262
#define	ENUM	263
#define	THREEDOTS	264
#define	SIGNED	265
#define	UNSIGNED	266
#define	LONG	267
#define	SHORT	268
#define	INT	269
#define	FLOAT	270
#define	DOUBLE	271
#define	CHAR	272
#define	TOKEN	273
#define	NUMBER	274
#define	TYPETOKEN	275
#define	ARRAY_DIM	276
#define	CCODE	277
#define	HTCODE	278
#define	PHCODE	279
#define	HCODE	280
#define	ACODE	281
#define	ATCODE	282
#define	PUBLIC	283
#define	PRIVATE	284
#define	PROTECTED	285
#define	CLASSWIDE	286
#define	ARGUMENT	287
#define	VIRTUAL	288
#define	SIGNAL	289
#define	OVERRIDE	290

#line 21 "parse.y"


#include "config.h"
#include <glib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "treefuncs.h"
#include "main.h"
#include "util.h"

#define _(x) (x)
	
GList *nodes = NULL;

static GList *class_nodes = NULL;
Node *class = NULL;

static char *chunk_size = NULL;
static char *bonobo_x_class = NULL;
static GList *typestack = NULL;
static GList *funcargs = NULL;
static GList *checks = NULL;
static int has_self = FALSE;
static int vararg = FALSE;
static Method *last_added_method = NULL;

/* destructor and initializer for variables */
static char *destructor = NULL;
static int destructor_line = 0;
static gboolean destructor_simple = TRUE;
static char *initializer = NULL;
static int initializer_line = 0;

static char *onerror = NULL;
static char *defreturn = NULL;

static GList *gtktypes = NULL;

/* this can be a global as we will only do one function at a time
   anyway */
static int the_scope = NO_SCOPE;

void free(void *ptr);
int yylex(void);

extern int ccode_line;
extern int line_no;

extern char *yytext;

static void
yyerror(char *str)
{
	char *out=NULL;
	char *p;
	
	if(strcmp(yytext,"\n")==0) {
		out=g_strconcat("Error: ",str," before newline",NULL);
	} else if(yytext[0]=='\0') {
		out=g_strconcat("Error: ", str, " at end of input", NULL);
	} else {
		char *tmp = g_strdup(yytext);
		while((p=strchr(tmp, '\n')))
			*p='.';

		out=g_strconcat("Error: ", str, " before '", tmp, "'", NULL);
		g_free(tmp);
	}

	fprintf(stderr, "%s:%d: %s\n", filename, line_no, out);
	g_free(out);
	
	exit(1);
}

static Type *
pop_type(void)
{
	Type *type = typestack->data;
	typestack = g_list_remove(typestack,typestack->data);
	return type;
}

static void
push_variable(char *name, int scope, int line_no, char *postfix)
{
	Node *var;
	Type *type = pop_type();

	type->postfix = postfix;
	
	var = new_variable(scope, type, name, line_no,
			   destructor, destructor_line,
			   destructor_simple,
			   initializer, initializer_line);
	class_nodes = g_list_append(class_nodes, var);
}

static void
push_function(int scope, int method, char *oid, char *id,
	      GString *cbuf, int line_no, int ccode_line,
	      gboolean vararg, GList *flags)
{
	Node *node;
	Type *type;
	char *c_cbuf;

	g_assert(scope != CLASS_SCOPE);
       
	if(method == INIT_METHOD || method == CLASS_INIT_METHOD) {
		type = (Type *)new_type(g_strdup("void"), NULL, NULL);
	} else {
		type = pop_type();
	}
	
	/* a complicated and ugly test to figure out if we have
	   the wrong number of types for a signal */
	if((method == SIGNAL_FIRST_METHOD ||
	    method == SIGNAL_LAST_METHOD) &&
	   g_list_length(gtktypes) != g_list_length(funcargs) &&
	   !(g_list_length(funcargs) == 1 &&
	     g_list_length(gtktypes) == 2 &&
	     strcmp(gtktypes->next->data, "NONE")==0)) {
		error_print(GOB_WARN, line_no,
			    _("The number of GTK arguments and "
			      "function arguments for a signal "
			      "don't seem to match"));
	}
	if(g_list_length(gtktypes) > 2) {
		GList *li;
		for(li = gtktypes->next; li; li = li->next) {
			if(strcmp(li->data, "NONE")==0) {
				error_print(GOB_ERROR, line_no,
					    _("NONE can only appear in an "
					      "argument list by itself"));
			}
		}
	}
	if(cbuf) {
		char *p;
		c_cbuf = p = cbuf->str;
		while(p && *p && (*p==' ' || *p=='\t' || *p=='\n' || *p=='\r'))
			p++;
		if(!p || !*p)
			c_cbuf = NULL;
	} else
		c_cbuf = NULL;

	node = new_method(scope, method, type, oid, gtktypes, flags,
			  id, funcargs, onerror, defreturn, c_cbuf, line_no,
			  ccode_line, vararg, method_unique_id++,
			  FALSE);

	last_added_method = (Method *)node;

	if(cbuf)
		g_string_free(cbuf,
			      /*only free segment if we haven't passed it
				above */
			      c_cbuf?FALSE:TRUE);
	gtktypes = NULL;
	funcargs = NULL;

	onerror = NULL;
	defreturn = NULL;

	class_nodes = g_list_append(class_nodes, node);
}

static void
free_all_global_state(void)
{
	g_free(onerror);
	onerror = NULL;
	g_free(defreturn);
	defreturn = NULL;

	g_free(chunk_size);
	chunk_size = NULL;
	
	g_list_foreach(gtktypes, (GFunc)g_free, NULL);
	g_list_free(gtktypes);
	gtktypes = NULL;

	free_node_list(funcargs);
	funcargs = NULL;
}

static void
push_funcarg(char *name, char *postfix)
{
	Node *node;
	Type *type = pop_type();

	type->postfix = postfix;
	
	node = new_funcarg(type, name, checks);
	checks = NULL;
	
	funcargs = g_list_append(funcargs, node);
}

static void
push_init_arg(char *name, int is_class)
{
	Node *node;
	Node *type;
	char *tn;
	
	if(is_class)
		tn = g_strconcat(((Class *)class)->otype,":Class",NULL);
	else
		tn = g_strdup(((Class *)class)->otype);

	type = new_type(tn, g_strdup("*"), NULL);
	node = new_funcarg((Type *)type,name,NULL);
	funcargs = g_list_prepend(funcargs, node);
}

static void
push_self(char *id, gboolean constant)
{
	Node *node;
	Node *type;
	GList *ch = NULL;
	type = new_type(g_strdup(((Class *)class)->otype),
			g_strdup(constant ? "const *" : "*"), NULL);
	ch = g_list_append(ch,new_check(NULL_CHECK,NULL));
	ch = g_list_append(ch,new_check(TYPE_CHECK,NULL));
	node = new_funcarg((Type *)type,id,ch);
	funcargs = g_list_prepend(funcargs, node);
}

static Variable *
find_var_or_die(const char *id, int line)
{
	GList *li;

	for(li = class_nodes; li != NULL; li = li->next) {
		Variable *var;
		Node *node = li->data;
		if(node->type != VARIABLE_NODE)
			continue;
		var = li->data;
		if(strcmp(var->id, id)==0)
			return var;
	}

	error_printf(GOB_ERROR, line, _("Variable %s not defined here"), id);

	g_assert_not_reached();
	return NULL;
}

static gboolean
set_return_value(char *type, char *val)
{
	if(strcmp(type, "onerror")==0) {
		if(!onerror) {
			onerror = val;
			return TRUE;
		} else
			return FALSE;
	} else if(strcmp(type, "defreturn")==0) {
		if(!defreturn) {
			defreturn = val;
			return TRUE;
		} else
			return FALSE;
	}
	return FALSE;
}


#line 298 "parse.y"
typedef union {
	char *id;
	GString *cbuf;
	GList *list;
	int line;
	int sigtype;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		270
#define	YYFLAG		-32768
#define	YYNTBASE	50

#define YYTRANSLATE(x) ((unsigned)(x) <= 290 ? yytranslate[x] : 88)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    48,     2,     2,     2,     2,     2,     2,    39,
    40,    44,     2,    45,    49,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    41,    47,
    42,    46,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    37,    43,    38,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,     7,    10,    12,    14,    16,    18,    20,    22,
    24,    27,    29,    34,    38,    44,    45,    51,    57,    60,
    62,    64,    67,    69,    71,    73,    75,    77,    79,    81,
    84,    88,    91,    95,    98,   101,   103,   105,   106,   112,
   119,   131,   140,   146,   152,   154,   158,   159,   163,   165,
   168,   170,   172,   174,   177,   180,   183,   187,   191,   194,
   197,   200,   202,   205,   207,   210,   212,   214,   216,   218,
   220,   222,   224,   226,   228,   230,   232,   234,   236,   239,
   242,   246,   249,   251,   255,   259,   262,   264,   269,   273,
   275,   278,   280,   291,   303,   313,   323,   332,   344,   353,
   359,   362,   367,   368,   370,   373,   375,   377,   380,   383,
   387,   392,   397,   399,   403,   405,   409,   411,   414,   418,
   425,   433,   436,   438,   440,   443,   446,   450,   454,   458,
   462,   464,   467
};

static const short yyrhs[] = {    52,
    53,    52,     0,    53,    52,     0,    52,    53,     0,    53,
     0,    23,     0,    26,     0,    24,     0,    25,     0,    27,
     0,    28,     0,    52,    51,     0,    51,     0,    54,    37,
    56,    38,     0,    54,    37,    38,     0,     3,    21,     4,
    21,    55,     0,     0,    39,    19,    19,    40,    55,     0,
    39,    19,    20,    40,    55,     0,    56,    57,     0,    57,
     0,    78,     0,    19,    78,     0,    62,     0,    63,     0,
    41,     0,    29,     0,    30,     0,    31,     0,    32,     0,
    19,    19,     0,    19,    37,    23,     0,    42,    87,     0,
    42,    37,    23,     0,    59,    60,     0,    60,    59,     0,
    60,     0,    59,     0,     0,    58,    67,    19,    61,    41,
     0,    58,    67,    19,    22,    61,    41,     0,    33,    65,
    64,    19,    19,    37,    23,    19,    37,    23,    41,     0,
    33,    65,    64,    19,    19,    37,    23,    41,     0,    33,
    65,    64,    19,    19,     0,    19,    39,    19,    67,    40,
     0,    19,     0,    39,    66,    40,     0,     0,    19,    43,
    66,     0,    19,     0,    68,    72,     0,    68,     0,    69,
     0,    19,     0,     5,    19,     0,    19,     5,     0,    71,
    19,     0,     5,    71,    19,     0,    71,    19,     5,     0,
    70,    69,     0,    21,    69,     0,     5,    69,     0,    21,
     0,    21,     5,     0,    70,     0,    70,     5,     0,     6,
     0,    18,     0,    14,     0,    15,     0,    13,     0,    16,
     0,    17,     0,    11,     0,    12,     0,     7,     0,     8,
     0,     9,     0,    44,     0,    44,     5,     0,    44,    72,
     0,    44,     5,    72,     0,    19,    75,     0,    75,     0,
    58,    19,    75,     0,    19,    58,    75,     0,    58,    75,
     0,    73,     0,    19,    39,    76,    40,     0,    76,    45,
    19,     0,    19,     0,    37,    23,     0,    41,     0,    35,
    65,    74,    67,    19,    39,    81,    40,    79,    77,     0,
    58,    35,    65,    73,    67,    19,    39,    81,    40,    79,
    77,     0,    34,    58,    67,    19,    39,    81,    40,    79,
    77,     0,    58,    34,    67,    19,    39,    81,    40,    79,
    77,     0,    34,    67,    19,    39,    81,    40,    79,    77,
     0,    36,    39,    21,    40,    67,    19,    39,    81,    40,
    79,    77,     0,    58,    67,    19,    39,    81,    40,    79,
    77,     0,    19,    39,    19,    40,    77,     0,    19,    80,
     0,    19,    80,    19,    80,     0,     0,    87,     0,    37,
    23,     0,     6,     0,    19,     0,    19,     5,     0,     5,
    19,     0,    19,    45,    82,     0,    19,     5,    45,    82,
     0,     5,    19,    45,    82,     0,    82,     0,    83,    45,
    10,     0,    83,     0,    83,    45,    84,     0,    84,     0,
    67,    19,     0,    67,    19,    22,     0,    67,    19,    39,
    19,    85,    40,     0,    67,    19,    22,    39,    19,    85,
    40,     0,    85,    86,     0,    86,     0,    19,     0,    46,
    87,     0,    47,    87,     0,    46,    42,    87,     0,    47,
    42,    87,     0,    42,    42,    87,     0,    48,    42,    87,
     0,    20,     0,    49,    20,     0,    19,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   316,   317,   318,   319,   322,   328,   334,   340,   346,   352,
   360,   361,   364,   369,   376,   382,   383,   395,   409,   410,
   413,   414,   422,   423,   424,   427,   428,   429,   430,   433,
   446,   462,   466,   474,   475,   476,   477,   478,   484,   487,
   491,   527,   556,   628,   637,   643,   644,   647,   650,   656,
   660,   667,   670,   673,   677,   681,   685,   690,   698,   702,
   707,   711,   714,   718,   721,   726,   727,   728,   729,   730,
   731,   732,   733,   734,   737,   738,   739,   742,   743,   744,
   748,   755,   767,   773,   785,   797,   800,   806,   811,   814,
   819,   820,   824,   840,   856,   872,   888,   899,   905,   915,
   938,   949,   968,   974,   975,   981,   982,   993,  1004,  1015,
  1025,  1035,  1045,  1048,  1049,  1052,  1053,  1056,  1059,  1062,
  1070,  1080,  1081,  1084,  1097,  1101,  1105,  1109,  1113,  1117,
  1123,  1124,  1128
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","CLASS",
"FROM","CONST","VOID","STRUCT","UNION","ENUM","THREEDOTS","SIGNED","UNSIGNED",
"LONG","SHORT","INT","FLOAT","DOUBLE","CHAR","TOKEN","NUMBER","TYPETOKEN","ARRAY_DIM",
"CCODE","HTCODE","PHCODE","HCODE","ACODE","ATCODE","PUBLIC","PRIVATE","PROTECTED",
"CLASSWIDE","ARGUMENT","VIRTUAL","SIGNAL","OVERRIDE","'{'","'}'","'('","')'",
"';'","'='","'|'","'*'","','","'>'","'<'","'!'","'-'","prog","ccode","ccodes",
"class","classdec","classflags","classcode","thing","scope","destructor","initializer",
"varoptions","variable","argument","argtype","flags","flaglist","type","specifier_list",
"spec_list","specifier","strunionenum","pointer","simplesigtype","fullsigtype",
"sigtype","tokenlist","codenocode","method","returnvals","retcode","funcargs",
"arglist","arglist1","arg","checklist","check","numtok", NULL
};
#endif

static const short yyr1[] = {     0,
    50,    50,    50,    50,    51,    51,    51,    51,    51,    51,
    52,    52,    53,    53,    54,    55,    55,    55,    56,    56,
    57,    57,    57,    57,    57,    58,    58,    58,    58,    59,
    59,    60,    60,    61,    61,    61,    61,    61,    62,    62,
    63,    63,    63,    64,    64,    65,    65,    66,    66,    67,
    67,    68,    68,    68,    68,    68,    68,    68,    69,    69,
    69,    69,    69,    69,    69,    70,    70,    70,    70,    70,
    70,    70,    70,    70,    71,    71,    71,    72,    72,    72,
    72,    73,    73,    74,    74,    74,    74,    75,    76,    76,
    77,    77,    78,    78,    78,    78,    78,    78,    78,    78,
    79,    79,    79,    80,    80,    81,    81,    81,    81,    81,
    81,    81,    81,    82,    82,    83,    83,    84,    84,    84,
    84,    85,    85,    86,    86,    86,    86,    86,    86,    86,
    87,    87,    87
};

static const short yyr2[] = {     0,
     3,     2,     2,     1,     1,     1,     1,     1,     1,     1,
     2,     1,     4,     3,     5,     0,     5,     5,     2,     1,
     1,     2,     1,     1,     1,     1,     1,     1,     1,     2,
     3,     2,     3,     2,     2,     1,     1,     0,     5,     6,
    11,     8,     5,     5,     1,     3,     0,     3,     1,     2,
     1,     1,     1,     2,     2,     2,     3,     3,     2,     2,
     2,     1,     2,     1,     2,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
     3,     2,     1,     3,     3,     2,     1,     4,     3,     1,
     2,     1,    10,    11,     9,     9,     8,    11,     8,     5,
     2,     4,     0,     1,     2,     1,     1,     2,     2,     3,
     4,     4,     1,     3,     1,     3,     1,     2,     3,     6,
     7,     2,     1,     1,     2,     2,     3,     3,     3,     3,
     1,     2,     1
};

static const short yydefact[] = {     0,
     0,     5,     7,     8,     6,     9,    10,    12,     0,     4,
     0,     0,    11,     3,     2,     0,     0,     1,     0,    26,
    27,    28,    29,    47,     0,    47,     0,    14,    25,     0,
    20,     0,    23,    24,    21,    16,     0,     0,     0,    22,
     0,     0,     0,    66,    75,    76,    77,    73,    74,    70,
    68,    69,    71,    72,    67,    53,    62,     0,     0,    51,
    52,    64,     0,     0,     0,    13,    19,     0,    47,     0,
     0,    15,     0,     0,    49,     0,    45,     0,     0,    54,
    61,     0,    55,    63,    60,     0,     0,    78,    50,    65,
    59,    56,     0,     0,    87,     0,    83,     0,     0,     0,
    38,     0,     0,     0,     0,    46,     0,     0,    57,     0,
     0,    79,    80,    58,     0,     0,     0,    82,     0,    86,
     0,     0,     0,     0,     0,     0,    38,     0,     0,    37,
    36,     0,     0,     0,     0,    92,   100,    48,     0,    43,
     0,     0,    66,    53,     0,     0,   113,   115,   117,    81,
    90,     0,    85,    84,     0,     0,     0,     0,    30,     0,
     0,     0,   133,   131,     0,     0,    32,    34,    35,    39,
    16,    16,    91,     0,     0,     0,    54,    55,     0,   118,
   103,     0,    88,     0,     0,     0,     0,     0,    31,    40,
   103,    33,   132,    17,    18,    44,     0,   103,     0,     0,
   110,   119,     0,     0,     0,   114,   116,    89,     0,     0,
   103,     0,     0,     0,    42,     0,   112,   111,     0,     0,
     0,   101,   104,    97,   103,     0,     0,     0,    99,     0,
    95,     0,   124,     0,     0,     0,     0,     0,   123,   105,
     0,     0,   103,    96,   103,     0,     0,     0,     0,   125,
     0,   126,     0,   120,   122,   102,    93,     0,     0,    41,
   121,   129,   127,   128,   130,    98,    94,     0,     0,     0
};

static const short yydefgoto[] = {   268,
     8,     9,    10,    11,    72,    30,    31,    32,   130,   131,
   132,    33,    34,    78,    42,    76,   145,    60,    61,    62,
    63,    89,    95,    96,    97,   152,   137,    35,   205,   222,
   146,   147,   148,   149,   238,   239,   223
};

static const short yypact[] = {   172,
    -4,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   172,   370,
    -5,    93,-32768,   370,   370,   173,    87,   370,   209,-32768,
-32768,-32768,-32768,    72,   155,    72,    84,-32768,-32768,   191,
-32768,   120,-32768,-32768,-32768,   104,   107,   128,   120,-32768,
   132,   133,   275,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   151,   343,   292,   146,   135,
-32768,   357,   158,   159,   160,-32768,-32768,   292,    72,   161,
   163,-32768,   143,   174,   169,   154,   162,   194,   371,-32768,
-32768,   196,-32768,   371,-32768,   197,   178,    16,-32768,   371,
-32768,   213,   223,   200,-32768,   292,-32768,   190,   212,   214,
    52,    11,    41,   195,   132,-32768,   216,   217,-32768,   198,
   309,   135,-32768,-32768,   207,   228,   230,-32768,    61,-32768,
   232,   292,   218,    61,   292,    68,     7,   309,     9,   219,
   239,   237,   220,   245,   272,-32768,-32768,-32768,   292,   265,
   309,   326,   279,    17,   293,   289,-32768,   291,-32768,-32768,
-32768,   -20,-32768,-32768,   307,   331,   309,   332,-32768,   329,
   312,   325,-32768,-32768,   344,   346,-32768,-32768,-32768,-32768,
   104,   104,-32768,   339,   358,   340,    64,   100,   292,    -6,
   372,   258,-32768,   380,   309,   351,   360,   362,-32768,-32768,
   372,-32768,-32768,-32768,-32768,-32768,    45,   372,   292,   292,
-32768,   363,   384,    28,    41,-32768,-32768,-32768,   364,   309,
   372,   309,    41,   368,-32768,    41,-32768,-32768,   387,   111,
   385,   388,-32768,-32768,   372,   369,    41,   373,-32768,   389,
-32768,   111,-32768,   374,    34,    50,   375,    70,-32768,-32768,
    28,    41,   372,-32768,   372,   377,   102,    18,    18,-32768,
    18,-32768,    18,-32768,-32768,-32768,-32768,    41,    41,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   410,   411,-32768
};

static const short yypgoto[] = {-32768,
   241,    71,   405,-32768,   -58,-32768,   390,   -14,   284,   294,
   295,-32768,-32768,-32768,   -17,   314,   -24,-32768,   -39,-32768,
   -40,   -76,   321,-32768,   -51,-32768,  -203,   404,  -184,   184,
  -122,  -104,-32768,   244,   199,  -154,  -129
};


#define	YYLAST		431


static const short yytable[] = {   167,
    59,   224,    82,    81,    39,   162,   213,    70,    64,   229,
    58,   113,   231,   216,    74,   202,    12,    85,   176,   183,
   112,   178,    91,   244,   184,   126,   227,   163,   164,   133,
   134,    16,   203,    86,   187,   150,   163,   164,   257,    81,
   242,   118,   120,    99,    81,   165,   163,   164,   129,    94,
    81,   100,   163,   164,   266,   267,  -107,   166,   258,    88,
   259,   179,   209,   214,   221,   153,   166,   154,   163,   164,
   126,   121,   118,   127,   201,   249,   166,   135,   117,   115,
    15,   136,   166,   255,    18,   215,   159,   226,   233,   228,
   128,   251,   255,   129,   217,   218,    17,   156,   166,   116,
   158,    82,    81,  -109,   160,   250,   252,    36,   199,   254,
    41,   234,   194,   195,   174,   235,   236,   237,   262,   263,
   233,   264,    65,   265,    43,    44,    45,    46,    47,   233,
    48,    49,    50,    51,    52,    53,    54,    55,    56,  -108,
    57,   261,    71,   234,   200,    38,    73,   235,   236,   237,
    75,    77,   234,    68,    69,    83,   235,   236,   237,    43,
    44,    45,    46,    47,    87,    48,    49,    50,    51,    52,
    53,    54,    55,    56,     1,    57,    92,    93,    88,   101,
    98,   102,   103,    20,    21,    22,    23,    20,    21,    22,
    23,    19,   104,   106,     2,     3,     4,     5,     6,     7,
   107,    20,    21,    22,    23,    24,    25,    26,    27,    19,
    28,   105,   108,    29,   109,   110,   111,   114,   119,    20,
    21,    22,    23,    24,    25,    26,    27,    37,    66,   122,
   123,    29,   124,   128,   139,   140,   141,    20,    21,    22,
    23,   115,    25,    26,    27,   116,   151,    38,   115,    13,
   155,    20,    21,    22,    23,    13,   157,   126,    13,   171,
   129,   116,    43,    44,    45,    46,    47,   206,    48,    49,
    50,    51,    52,    53,    54,    55,    56,   170,    57,    79,
    44,    45,    46,    47,   172,    48,    49,    50,    51,    52,
    53,    54,    55,    80,   173,    57,    43,    44,    45,    46,
    47,   175,    48,    49,    50,    51,    52,    53,    54,    55,
    56,   180,    57,   142,   143,    45,    46,    47,  -106,    48,
    49,    50,    51,    52,    53,    54,    55,   144,   181,    57,
    79,    44,    45,    46,    47,   182,    48,    49,    50,    51,
    52,    53,    54,    55,   177,   185,    57,    84,    44,   186,
   188,   189,   190,    48,    49,    50,    51,    52,    53,    54,
    55,    90,    44,    57,   191,   193,   192,    48,    49,    50,
    51,    52,    53,    54,    55,    79,    44,    57,   196,   198,
   197,    48,    49,    50,    51,    52,    53,    54,    55,   210,
   204,    57,     2,     3,     4,     5,     6,     7,   208,   211,
   212,   219,   220,   225,   230,   232,   241,   240,   243,   269,
   270,   246,   245,    14,   169,   248,   253,   260,   138,    67,
   125,   161,    40,   168,   256,   207,     0,     0,     0,     0,
   247
};

static const short yycheck[] = {   129,
    25,   205,    43,    43,    19,   128,   191,    32,    26,   213,
    25,    88,   216,   198,    39,    22,    21,    57,   141,    40,
     5,     5,    62,   227,    45,    19,   211,    19,    20,    19,
    20,    37,    39,    58,   157,   112,    19,    20,   242,    79,
   225,    93,    94,    68,    84,    37,    19,    20,    42,    64,
    90,    69,    19,    20,   258,   259,    40,    49,   243,    44,
   245,    45,   185,    19,    37,   117,    49,   119,    19,    20,
    19,    96,   124,    22,   179,    42,    49,    37,    93,    19,
    10,    41,    49,   238,    14,    41,    19,   210,    19,   212,
    39,    42,   247,    42,   199,   200,     4,   122,    49,    39,
   125,   142,   142,    40,    37,   235,   236,    21,    45,    40,
    39,    42,   171,   172,   139,    46,    47,    48,   248,   249,
    19,   251,    39,   253,     5,     6,     7,     8,     9,    19,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    40,
    21,    40,    39,    42,    45,    39,    19,    46,    47,    48,
    19,    19,    42,    34,    35,     5,    46,    47,    48,     5,
     6,     7,     8,     9,    19,    11,    12,    13,    14,    15,
    16,    17,    18,    19,     3,    21,    19,    19,    44,    19,
    21,    19,    40,    29,    30,    31,    32,    29,    30,    31,
    32,    19,    19,    40,    23,    24,    25,    26,    27,    28,
    39,    29,    30,    31,    32,    33,    34,    35,    36,    19,
    38,    43,    19,    41,    19,    19,    39,     5,    19,    29,
    30,    31,    32,    33,    34,    35,    36,    19,    38,    40,
    19,    41,    19,    39,    19,    19,    39,    29,    30,    31,
    32,    19,    34,    35,    36,    39,    19,    39,    19,     9,
    19,    29,    30,    31,    32,    15,    39,    19,    18,    40,
    42,    39,     5,     6,     7,     8,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    41,    21,     5,
     6,     7,     8,     9,    40,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    23,    21,     5,     6,     7,     8,
     9,    37,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    19,    21,     5,     6,     7,     8,     9,    40,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    40,    21,
     5,     6,     7,     8,     9,    45,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    39,    21,     5,     6,    19,
    19,    23,    41,    11,    12,    13,    14,    15,    16,    17,
    18,     5,     6,    21,    40,    20,    23,    11,    12,    13,
    14,    15,    16,    17,    18,     5,     6,    21,    40,    40,
    23,    11,    12,    13,    14,    15,    16,    17,    18,    39,
    19,    21,    23,    24,    25,    26,    27,    28,    19,    40,
    39,    39,    19,    40,    37,    19,    19,    23,    40,     0,
     0,    23,    40,     9,   131,    42,    42,    41,   105,    30,
   100,   127,    19,   130,   241,   182,    -1,    -1,    -1,    -1,
   232
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 316 "parse.y"
{ ; ;
    break;}
case 2:
#line 317 "parse.y"
{ ; ;
    break;}
case 3:
#line 318 "parse.y"
{ ; ;
    break;}
case 4:
#line 319 "parse.y"
{ ; ;
    break;}
case 5:
#line 322 "parse.y"
{
			Node *node = new_ccode(C_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 6:
#line 328 "parse.y"
{
			Node *node = new_ccode(H_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 7:
#line 334 "parse.y"
{
			Node *node = new_ccode(HT_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 8:
#line 340 "parse.y"
{
			Node *node = new_ccode(PH_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 9:
#line 346 "parse.y"
{
			Node *node = new_ccode(A_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 10:
#line 352 "parse.y"
{
			Node *node = new_ccode(AT_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 11:
#line 360 "parse.y"
{ ; ;
    break;}
case 12:
#line 361 "parse.y"
{ ; ;
    break;}
case 13:
#line 364 "parse.y"
{
			((Class *)class)->nodes = class_nodes;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 14:
#line 369 "parse.y"
{
			((Class *)class)->nodes = NULL;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 15:
#line 376 "parse.y"
{
			class = new_class (yyvsp[-3].id, yyvsp[-1].id,
					   bonobo_x_class, chunk_size, NULL);
						;
    break;}
case 17:
#line 383 "parse.y"
{
			if(strcmp(yyvsp[-3].id,"chunks") == 0) {
				g_free (chunk_size);
				chunk_size = g_strdup(yyvsp[-2].id);
			} else if(strcmp(yyvsp[-3].id,"BonoboX") == 0) {
				g_free (bonobo_x_class);
				bonobo_x_class = g_strdup(yyvsp[-2].id);
			} else {
				yyerror(_("parse error"));
				YYERROR;
			}
		;
    break;}
case 18:
#line 395 "parse.y"
{
			if(strcmp(yyvsp[-3].id,"chunks") == 0) {
				g_free (chunk_size);
				if(atoi(yyvsp[-2].id) != 0)
					chunk_size = g_strdup(yyvsp[-2].id);
				else
					chunk_size = NULL;
			} else {
				yyerror(_("parse error"));
				YYERROR;
			}
		;
    break;}
case 19:
#line 409 "parse.y"
{ ; ;
    break;}
case 20:
#line 410 "parse.y"
{ ; ;
    break;}
case 21:
#line 413 "parse.y"
{ ; ;
    break;}
case 22:
#line 414 "parse.y"
{
			if (strcmp (yyvsp[-1].id, "BonoboX") != 0) {
				g_free(yyvsp[-1].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			last_added_method->bonobo_x_func = TRUE;
						;
    break;}
case 23:
#line 422 "parse.y"
{ ; ;
    break;}
case 24:
#line 423 "parse.y"
{ ; ;
    break;}
case 25:
#line 424 "parse.y"
{ ; ;
    break;}
case 26:
#line 427 "parse.y"
{ the_scope = PUBLIC_SCOPE; ;
    break;}
case 27:
#line 428 "parse.y"
{ the_scope = PRIVATE_SCOPE; ;
    break;}
case 28:
#line 429 "parse.y"
{ the_scope = PROTECTED_SCOPE; ;
    break;}
case 29:
#line 430 "parse.y"
{ the_scope = CLASS_SCOPE; ;
    break;}
case 30:
#line 433 "parse.y"
{
			if(strcmp(yyvsp[-1].id, "destroywith")==0) {
				g_free(yyvsp[-1].id);
				destructor = yyvsp[0].id;
				destructor_line = line_no;
				destructor_simple = TRUE;
			} else {
				g_free(yyvsp[-1].id);
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
				;
    break;}
case 31:
#line 446 "parse.y"
{
			if(strcmp(yyvsp[-2].id, "destroy")==0) {
				g_free(yyvsp[-2].id);
				destructor = (yyvsp[0].cbuf)->str;
				g_string_free(yyvsp[0].cbuf, FALSE);
				destructor_line = ccode_line;
				destructor_simple = FALSE;
			} else {
				g_free(yyvsp[-2].id);
				g_string_free(yyvsp[0].cbuf, TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 32:
#line 462 "parse.y"
{
			initializer = yyvsp[0].id;
			initializer_line = ccode_line;
				;
    break;}
case 33:
#line 466 "parse.y"
{
			initializer = (yyvsp[0].cbuf)->str;
			initializer_line = ccode_line;
			g_string_free(yyvsp[0].cbuf, FALSE);
				;
    break;}
case 34:
#line 474 "parse.y"
{ ; ;
    break;}
case 35:
#line 475 "parse.y"
{ ; ;
    break;}
case 36:
#line 476 "parse.y"
{ destructor = NULL; ;
    break;}
case 37:
#line 477 "parse.y"
{ initializer = NULL; ;
    break;}
case 38:
#line 478 "parse.y"
{
			destructor = NULL;
			initializer = NULL;
					;
    break;}
case 39:
#line 484 "parse.y"
{
			push_variable(yyvsp[-2].id, the_scope,yyvsp[-4].line, NULL);
						;
    break;}
case 40:
#line 487 "parse.y"
{
			push_variable(yyvsp[-3].id, the_scope, yyvsp[-5].line, yyvsp[-2].id);
						;
    break;}
case 41:
#line 491 "parse.y"
{
			if(strcmp(yyvsp[-6].id,"get")==0 &&
			   strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,type,yyvsp[-9].list,yyvsp[-7].id,
						    (yyvsp[-4].cbuf)->str,yyvsp[-5].line,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    yyvsp[-10].line);
				g_string_free(yyvsp[-4].cbuf,FALSE);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-6].id,"set")==0 &&
				strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,type,yyvsp[-9].list,yyvsp[-7].id,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    (yyvsp[-4].cbuf)->str,yyvsp[-5].line,
						    yyvsp[-10].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				g_string_free(yyvsp[-4].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-8].id); g_free(yyvsp[-7].id);
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				g_list_foreach(yyvsp[-9].list,(GFunc)g_free,NULL);
				g_list_free(yyvsp[-9].list);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				g_string_free(yyvsp[-4].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 42:
#line 527 "parse.y"
{
			if(strcmp(yyvsp[-3].id, "get") == 0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id, type, yyvsp[-6].list, yyvsp[-4].id,
						    (yyvsp[-1].cbuf)->str, yyvsp[-2].line,
						    NULL, 0, yyvsp[-7].line);
				g_string_free(yyvsp[-1].cbuf, FALSE);
				class_nodes = g_list_append(class_nodes, node);
			} else if(strcmp(yyvsp[-3].id, "set") == 0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id, type, yyvsp[-6].list, yyvsp[-4].id,
						    NULL, 0, (yyvsp[-1].cbuf)->str,
						    yyvsp[-2].line, yyvsp[-7].line);
				g_string_free(yyvsp[-1].cbuf, FALSE);
				class_nodes = g_list_append(class_nodes, node);
			} else {
				g_free(yyvsp[-3].id); g_free(yyvsp[-5].id);
				g_free(yyvsp[-4].id);
				g_list_foreach(yyvsp[-6].list, (GFunc)g_free, NULL);
				g_list_free(yyvsp[-6].list);
				g_string_free(yyvsp[-1].cbuf, TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 43:
#line 556 "parse.y"
{
			Node *node;
			char *get, *set = NULL;
			Variable *var;
			Type *type;
			char *root;
			
			if(strcmp(yyvsp[0].id, "link")!=0 &&
			   strcmp(yyvsp[0].id, "stringlink")!=0 &&
			   strcmp(yyvsp[0].id, "objectlink")!=0) {
				g_free(yyvsp[0].id); g_free(yyvsp[-2].id);
				g_free(yyvsp[-1].id);
				g_list_foreach(yyvsp[-3].list,(GFunc)g_free,NULL);
				g_list_free(yyvsp[-3].list);
				yyerror(_("parse error"));
				YYERROR;
			}

			type = pop_type();

			var = find_var_or_die(yyvsp[-1].id, yyvsp[-4].line);
			if(var->scope == PRIVATE_SCOPE)
				root = "self->_priv";
			else if(var->scope == CLASS_SCOPE) {
				root = "SELF_GET_CLASS(self)";
				if(no_self_alias)
					error_print(GOB_ERROR, yyvsp[-4].line,
						    _("Self aliases needed when autolinking to a classwide member"));
			} else
				root = "self";

			if(strcmp(yyvsp[0].id, "link")==0) {
				set = g_strdup_printf("%s->%s = ARG;",
						      root, yyvsp[-1].id);
			} else if(strcmp(yyvsp[0].id, "stringlink")==0) {
				set = g_strdup_printf("g_free(%s->%s); "
						      "%s->%s = g_strdup(ARG);",
						      root, yyvsp[-1].id,
						      root, yyvsp[-1].id);
			} else if(strcmp(yyvsp[0].id, "objectlink")==0) {
				set = g_strdup_printf(
				  "if (ARG != NULL) "
				   "gtk_object_ref (GTK_OBJECT (ARG)); "
				  "if (%s->%s != NULL) "
				   "gtk_object_unref (GTK_OBJECT (%s->%s)); "
				  "%s->%s = ARG;",
				  root, yyvsp[-1].id,
				  root, yyvsp[-1].id,
				  root, yyvsp[-1].id);
			} else {
				g_assert_not_reached();
			}

			if(strcmp(yyvsp[0].id, "stringlink")==0) {
				get = g_strdup_printf("ARG = g_strdup(%s->%s);", root, yyvsp[-1].id);
			} else
				/* For everything else, get is just straight assignment */
				get = g_strdup_printf("ARG = %s->%s;", root, yyvsp[-1].id);

			g_free(yyvsp[0].id);


			if(!type)
				type = copy_type(var->vtype);

			node = new_argument(yyvsp[-2].id, type, yyvsp[-3].list,
					    yyvsp[-1].id, get, yyvsp[-4].line,
					    set, yyvsp[-4].line, yyvsp[-4].line);
			class_nodes = g_list_append(class_nodes,node);
						;
    break;}
case 44:
#line 628 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"type")!=0) {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			yyval.id = yyvsp[-4].id;
						;
    break;}
case 45:
#line 637 "parse.y"
{
			yyval.id = yyvsp[0].id;
			typestack = g_list_prepend(typestack,NULL);
						;
    break;}
case 46:
#line 643 "parse.y"
{ yyval.list = yyvsp[-1].list; ;
    break;}
case 47:
#line 644 "parse.y"
{ yyval.list = NULL; ;
    break;}
case 48:
#line 647 "parse.y"
{
			yyval.list = g_list_append(yyvsp[0].list,yyvsp[-2].id);
						;
    break;}
case 49:
#line 650 "parse.y"
{
			yyval.list = g_list_append(NULL,yyvsp[0].id);
						;
    break;}
case 50:
#line 656 "parse.y"
{
			Node *node = new_type(yyvsp[-1].id, yyvsp[0].id, NULL);
			typestack = g_list_prepend(typestack,node);
							;
    break;}
case 51:
#line 660 "parse.y"
{
			Node *node = new_type(yyvsp[0].id, NULL, NULL);
			typestack = g_list_prepend(typestack,node);
							;
    break;}
case 52:
#line 667 "parse.y"
{
			yyval.id = yyvsp[0].id;
							;
    break;}
case 53:
#line 670 "parse.y"
{
			yyval.id = yyvsp[0].id;
							;
    break;}
case 54:
#line 673 "parse.y"
{
			yyval.id = g_strconcat("const ", yyvsp[0].id, NULL);
			g_free(yyvsp[0].id);
							;
    break;}
case 55:
#line 677 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id, " const", NULL);
			g_free(yyvsp[-1].id);
							;
    break;}
case 56:
#line 681 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id, " ", yyvsp[0].id, NULL);
			g_free(yyvsp[0].id);
							;
    break;}
case 57:
#line 685 "parse.y"
{
			yyval.id = g_strconcat("const ", yyvsp[-1].id, " ",
					     yyvsp[0].id, NULL);
			g_free(yyvsp[0].id);
							;
    break;}
case 58:
#line 690 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-2].id, " ",
					     yyvsp[-1].id, " const", NULL);
			g_free(yyvsp[-1].id);
							;
    break;}
case 59:
#line 698 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id, " ", yyvsp[0].id, NULL);
			g_free(yyvsp[0].id);
							;
    break;}
case 60:
#line 702 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id, " ", yyvsp[0].id, NULL);
			g_free(yyvsp[-1].id);
			g_free(yyvsp[0].id);
							;
    break;}
case 61:
#line 707 "parse.y"
{
			yyval.id = g_strconcat("const ", yyvsp[0].id, NULL);
			g_free(yyvsp[0].id);
							;
    break;}
case 62:
#line 711 "parse.y"
{
			yyval.id = yyvsp[0].id;
							;
    break;}
case 63:
#line 714 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id, " const", NULL);
			g_free(yyvsp[-1].id);
							;
    break;}
case 64:
#line 718 "parse.y"
{
			yyval.id = g_strdup(yyvsp[0].id);
							;
    break;}
case 65:
#line 721 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id, " const", NULL);
							;
    break;}
case 66:
#line 726 "parse.y"
{ yyval.id = "void"; ;
    break;}
case 67:
#line 727 "parse.y"
{ yyval.id = "char"; ;
    break;}
case 68:
#line 728 "parse.y"
{ yyval.id = "short"; ;
    break;}
case 69:
#line 729 "parse.y"
{ yyval.id = "int"; ;
    break;}
case 70:
#line 730 "parse.y"
{ yyval.id = "long"; ;
    break;}
case 71:
#line 731 "parse.y"
{ yyval.id = "float"; ;
    break;}
case 72:
#line 732 "parse.y"
{ yyval.id = "double"; ;
    break;}
case 73:
#line 733 "parse.y"
{ yyval.id = "signed"; ;
    break;}
case 74:
#line 734 "parse.y"
{ yyval.id = "unsigned"; ;
    break;}
case 75:
#line 737 "parse.y"
{ yyval.id = "struct"; ;
    break;}
case 76:
#line 738 "parse.y"
{ yyval.id = "union"; ;
    break;}
case 77:
#line 739 "parse.y"
{ yyval.id = "enum"; ;
    break;}
case 78:
#line 742 "parse.y"
{ yyval.id = g_strdup("*"); ;
    break;}
case 79:
#line 743 "parse.y"
{ yyval.id = g_strdup("* const"); ;
    break;}
case 80:
#line 744 "parse.y"
{
				yyval.id = g_strconcat("*", yyvsp[0].id, NULL);
				g_free(yyvsp[0].id);
					;
    break;}
case 81:
#line 748 "parse.y"
{
				yyval.id = g_strconcat("* const", yyvsp[0].id, NULL);
				g_free(yyvsp[0].id);
					;
    break;}
case 82:
#line 755 "parse.y"
{
			if(strcmp(yyvsp[-1].id, "first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id, "last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 83:
#line 767 "parse.y"
{
			yyval.sigtype = SIGNAL_LAST_METHOD;
					;
    break;}
case 84:
#line 773 "parse.y"
{
			if(strcmp(yyvsp[-1].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 85:
#line 785 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-2].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-2].id);
				YYERROR;
			}
			g_free(yyvsp[-2].id);
					;
    break;}
case 86:
#line 797 "parse.y"
{
			yyval.sigtype = SIGNAL_LAST_METHOD;
					;
    break;}
case 87:
#line 800 "parse.y"
{
			/* the_scope was default thus public */
			the_scope = PUBLIC_SCOPE;
					;
    break;}
case 88:
#line 806 "parse.y"
{
			gtktypes = g_list_prepend(gtktypes, yyvsp[-3].id);
						;
    break;}
case 89:
#line 811 "parse.y"
{
			gtktypes = g_list_append(gtktypes, yyvsp[0].id);
						;
    break;}
case 90:
#line 814 "parse.y"
{ 
			gtktypes = g_list_append(gtktypes, yyvsp[0].id);
       						;
    break;}
case 91:
#line 819 "parse.y"
{ yyval.cbuf = yyvsp[0].cbuf; ;
    break;}
case 92:
#line 820 "parse.y"
{ yyval.cbuf = NULL; ;
    break;}
case 93:
#line 824 "parse.y"
{
			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, yyvsp[-7].sigtype,NULL,
				      yyvsp[-5].id, yyvsp[0].cbuf,yyvsp[-9].line,
				      ccode_line, vararg, yyvsp[-8].list);
									;
    break;}
case 94:
#line 840 "parse.y"
{
			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, yyvsp[-7].sigtype, NULL,
				      yyvsp[-5].id, yyvsp[0].cbuf, yyvsp[-9].line,
				      ccode_line, vararg, yyvsp[-8].list);
									;
    break;}
case 95:
#line 856 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[0].cbuf, yyvsp[-8].line,
				      ccode_line, vararg, NULL);
									;
    break;}
case 96:
#line 872 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[0].cbuf, yyvsp[-7].line,
				      ccode_line, vararg, NULL);
									;
    break;}
case 97:
#line 888 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			push_function(PUBLIC_SCOPE, VIRTUAL_METHOD, NULL,
				      yyvsp[-5].id, yyvsp[0].cbuf, yyvsp[-7].line,
				      ccode_line, vararg, NULL);
									;
    break;}
case 98:
#line 899 "parse.y"
{
			push_function(NO_SCOPE, OVERRIDE_METHOD, yyvsp[-8].id,
				      yyvsp[-5].id, yyvsp[0].cbuf,
				      yyvsp[-10].line, ccode_line,
				      vararg, NULL);
									;
    break;}
case 99:
#line 905 "parse.y"
{
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, REGULAR_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[0].cbuf, yyvsp[-7].line, ccode_line,
				      vararg, NULL);
								;
    break;}
case 100:
#line 915 "parse.y"
{
			if(strcmp(yyvsp[-4].id, "init")==0) {
				push_init_arg(yyvsp[-2].id,FALSE);
				push_function(NO_SCOPE, INIT_METHOD, NULL,
					      yyvsp[-4].id, yyvsp[0].cbuf, yyvsp[-3].line,
					      ccode_line, FALSE, NULL);
			} else if(strcmp(yyvsp[-4].id, "class_init")==0) {
				push_init_arg(yyvsp[-2].id,TRUE);
				push_function(NO_SCOPE, CLASS_INIT_METHOD, NULL,
					      yyvsp[-4].id, yyvsp[0].cbuf, yyvsp[-3].line,
					      ccode_line, FALSE, NULL);
			} else {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				g_string_free(yyvsp[0].cbuf,TRUE);
				yyerror(_("parse error "
					  "(untyped blocks must be init or "
					  "class_init)"));
				YYERROR;
			}
						;
    break;}
case 101:
#line 938 "parse.y"
{
			g_free(onerror); onerror = NULL;
			g_free(defreturn); defreturn = NULL;
			if(!set_return_value(yyvsp[-1].id, yyvsp[0].id)) {
				g_free(yyvsp[-1].id);
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 102:
#line 949 "parse.y"
{
			g_free(onerror); onerror = NULL;
			g_free(defreturn); defreturn = NULL;
			if(!set_return_value(yyvsp[-3].id, yyvsp[-2].id)) {
				g_free(yyvsp[-3].id); g_free(yyvsp[-2].id);
				g_free(yyvsp[-1].id); g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			if(!set_return_value(yyvsp[-1].id, yyvsp[0].id)) {
				onerror = defreturn = NULL;
				g_free(yyvsp[-3].id); g_free(yyvsp[-2].id);
				g_free(yyvsp[-1].id); g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-3].id);
			g_free(yyvsp[-1].id);
						;
    break;}
case 103:
#line 968 "parse.y"
{
			g_free(onerror); onerror = NULL;
			g_free(defreturn); defreturn = NULL;
					;
    break;}
case 104:
#line 974 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 105:
#line 975 "parse.y"
{
			yyval.id = (yyvsp[1].cbuf)->str;
			g_string_free(yyvsp[1].cbuf, FALSE);
					;
    break;}
case 106:
#line 981 "parse.y"
{ vararg = FALSE; has_self = FALSE; ;
    break;}
case 107:
#line 982 "parse.y"
{
			vararg = FALSE;
			has_self = TRUE;
			if(strcmp(yyvsp[0].id,"self")==0)
				push_self(yyvsp[0].id, FALSE);
			else {
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
       					;
    break;}
case 108:
#line 993 "parse.y"
{
			vararg = FALSE;
			has_self = TRUE;
			if(strcmp(yyvsp[-1].id,"self")==0)
				push_self(yyvsp[-1].id, TRUE);
			else {
				g_free(yyvsp[-1].id);
				yyerror(_("parse error"));
				YYERROR;
			}
       					;
    break;}
case 109:
#line 1004 "parse.y"
{
			vararg = FALSE;
			has_self = TRUE;
			if(strcmp(yyvsp[0].id,"self")==0)
				push_self(yyvsp[0].id, TRUE);
			else {
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
       					;
    break;}
case 110:
#line 1015 "parse.y"
{
			has_self = TRUE;
			if(strcmp(yyvsp[-2].id,"self")==0)
				push_self(yyvsp[-2].id, FALSE);
			else {
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 111:
#line 1025 "parse.y"
{
			has_self = TRUE;
			if(strcmp(yyvsp[-3].id,"self")==0)
				push_self(yyvsp[-3].id, TRUE);
			else {
				g_free(yyvsp[-3].id);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 112:
#line 1035 "parse.y"
{
			has_self = TRUE;
			if(strcmp(yyvsp[-2].id,"self")==0)
				push_self(yyvsp[-2].id, TRUE);
			else {
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 113:
#line 1045 "parse.y"
{ has_self = FALSE; ;
    break;}
case 114:
#line 1048 "parse.y"
{ vararg = TRUE; ;
    break;}
case 115:
#line 1049 "parse.y"
{ vararg = FALSE; ;
    break;}
case 116:
#line 1052 "parse.y"
{ ; ;
    break;}
case 117:
#line 1053 "parse.y"
{ ; ;
    break;}
case 118:
#line 1056 "parse.y"
{
			push_funcarg(yyvsp[0].id,NULL);
								;
    break;}
case 119:
#line 1059 "parse.y"
{
			push_funcarg(yyvsp[-1].id,yyvsp[0].id);
								;
    break;}
case 120:
#line 1062 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-4].id,NULL);
								;
    break;}
case 121:
#line 1070 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-5].id,yyvsp[-4].id);
								;
    break;}
case 122:
#line 1080 "parse.y"
{ ; ;
    break;}
case 123:
#line 1081 "parse.y"
{ ; ;
    break;}
case 124:
#line 1084 "parse.y"
{
			if(strcmp(yyvsp[0].id,"type")==0) {
				Node *node = new_check(TYPE_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else if(strcmp(yyvsp[0].id,"null")==0) {
				Node *node = new_check(NULL_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[0].id);
					;
    break;}
case 125:
#line 1097 "parse.y"
{
			Node *node = new_check(GT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 126:
#line 1101 "parse.y"
{
			Node *node = new_check(LT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 127:
#line 1105 "parse.y"
{
			Node *node = new_check(GE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 128:
#line 1109 "parse.y"
{
			Node *node = new_check(LE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 129:
#line 1113 "parse.y"
{
			Node *node = new_check(EQ_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 130:
#line 1117 "parse.y"
{
			Node *node = new_check(NE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 131:
#line 1123 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 132:
#line 1124 "parse.y"
{
			yyval.id = g_strconcat("-",yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
					;
    break;}
case 133:
#line 1128 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 1131 "parse.y"

